# Diffusion Alignment as Sampling

This project implements Diffusion Alignment as Sampling (DAS)

## Installation

'''bash
conda env create -f das.yml
'''

## Usage

### Aesthetic Score

To run the Aesthetic Score sampling:

```bash
CUDA_VISIBLE_DEVICES=0,1,2,3 accelerate launch SMC.py --config config/smc.py:aesthetic
```

### PickScore

To run the PickScore sampling:

```bash
CUDA_VISIBLE_DEVICES=0,1,2,3 accelerate launch SMC.py --config config/smc.py:pick
```

## Evaluation

Evaluation can be performed using the `eval.ipynb` Jupyter notebook. 

## Mixture of Gaussians Experiment

The Mixture of Gaussians experiment can be reproduced using two Jupyter notebooks:

1. `GMM1_save.ipynb`
2. `GMM2_save.ipynb`
